#include <stdlib.h>
#include "infomain.h"

#include "infomain.moc"

MainWidget::MainWidget(QWidget *parent) : QWidget(parent)
{
  uinline = new QLabel(this);
  uinline->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
  ipline = new QLabel(this);
  ipline->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
  nickline = new QLabel(this);
  nickline->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
  emailline = new QLabel(this);
  emailline->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
  firstline = new QLabel(this);
  firstline->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
  lastline = new QLabel(this);
  lastline->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
  uinlabel = new QLabel(uinline, "ICQ#",this);
  iplabel = new QLabel(ipline, "Current/Last IP",this);
  nicklabel = new QLabel(nickline, "Nickname",this);
  emaillabel = new QLabel(emailline, "EMail",this);
  firstlabel = new QLabel(firstline, "First Name",this);
  lastlabel = new QLabel(lastline, "Last Name",this);
}

MainWidget::~MainWidget()
{
  if(uinlabel)
    delete uinlabel;
  if(iplabel)
    delete iplabel;
  if(nicklabel)
    delete nicklabel;
  if(emaillabel)
    delete emaillabel;
  if(firstlabel)
    delete firstlabel;
  if(lastlabel)
    delete lastlabel;
  if(uinline)
    delete uinline;
  if(ipline)
    delete ipline;
  if(nickline)
    delete nickline;
  if(emailline)
    delete emailline;
  if(firstline)
    delete firstline;
  if(lastline)
    delete lastline;
}

void MainWidget::resizeEvent(QResizeEvent *re)
{
  QWidget::resizeEvent(re);
  int hlbl = QMAX(QMAX(QMAX(uinlabel->sizeHint().height(),iplabel->sizeHint().height()),
             QMAX(nicklabel->sizeHint().height(),emaillabel->sizeHint().height())),
             QMAX(firstlabel->sizeHint().height(),lastlabel->sizeHint().height()));
  int hline = QMAX(QMAX(QMAX(uinline->sizeHint().height(),ipline->sizeHint().height()),
              QMAX(nickline->sizeHint().height(),emailline->sizeHint().height())),
              QMAX(firstline->sizeHint().height(),lastline->sizeHint().height()));
  int w = (width()-20)/2;
  int h = (height()-2)/3;
  uinlabel->setGeometry(6,5,w,hlbl);
  uinline->setGeometry(6,5+hlbl,w,hline);
  iplabel->setGeometry(w+15,5,w,hlbl);
  ipline->setGeometry(w+15,5+hlbl,w,hline);
  nicklabel->setGeometry(6,5+h,w,hlbl);
  nickline->setGeometry(6,5+h+hlbl,w,hline);
  emaillabel->setGeometry(w+15,5+h,w,hlbl);
  emailline->setGeometry(w+15,5+h+hlbl,w,hline);
  firstlabel->setGeometry(6,5+h*2,w,hlbl);
  firstline->setGeometry(6,5+h*2+hlbl,w,hline);
  lastlabel->setGeometry(w+15,5+h*2,w,hlbl);
  lastline->setGeometry(w+15,5+h*2+hlbl,w,hline);
}

void MainWidget::setInfo(unsigned long puin, const char *pip, const char *pnick, const char *pemail, const char *pfirst, const char *plast)
{
  QString stmp;
  stmp.setNum(puin);
  uinline->setText((const char*)stmp);
  ipline->setText(pip);
  nickline->setText(pnick);
  emailline->setText(pemail);
  firstline->setText(pfirst);
  lastline->setText(plast);
}
