#include "preferences.h"
#include "mainwindow.h"

#include "preferences.moc"

Preferences::Preferences() : QTabDialog(0, 0, TRUE)
{
  setCaption("Preferences");
  userwidget = new UserWidget(this);
  addTab(userwidget, "User");
  serverwidget = new ServerWidget(this);
  addTab(serverwidget, "Server");
  otherwidget = new OtherWidget(this);
  addTab(otherwidget, "Other");
  setCancelButton();
  connect(this, SIGNAL(applyButtonPressed()), SLOT(savePreferences()));
  resize(250,220);
}

Preferences::~Preferences()
{
  if(userwidget)
    delete userwidget;
  if(serverwidget)
    delete serverwidget;
}

void Preferences::setUser(unsigned long uin, const char *nick, const char *pass)
{
  userwidget->setInfo(uin, nick, pass);
}

void Preferences::setServer(const char *host, int port)
{
  serverwidget->setInfo(host, port);
}

void Preferences::setOther(int rus, int lvl, const char *logfile)
{
  otherwidget->setInfo(rus, lvl, logfile);
}

void Preferences::savePreferences()
{
  ((MainWindow*)(kapp->topWidget()))->saveConfig(userwidget->uin(),userwidget->nick(),
  userwidget->pass(),serverwidget->host(),serverwidget->port(),otherwidget->rus(),
  otherwidget->level(),otherwidget->logfile());
}
