#include "prefother.h"

#include "prefother.moc"

OtherWidget::OtherWidget(QWidget *parent) : QWidget(parent)
{
  mainlabel = new QLabel("Other Settings:",this);
  recodebox = new QCheckBox("koi8-r -- cp1251 recoding", this);
	logbox = new QGroupBox("Logging", this);
  levelbox = new QComboBox(this);
	levelbox->insertItem("Off");
	levelbox->insertItem("Fatal");
	levelbox->insertItem("Error");
	levelbox->insertItem("Warning");
	levelbox->insertItem("Message");
	levellabel = new QLabel(levelbox, "Level:", this);
	logline = new QLineEdit(this);
	loglabel = new QLabel(logline, "File:", this);
}

OtherWidget::~OtherWidget()
{
  if(mainlabel)
    delete mainlabel;
  if(recodebox)
    delete recodebox;
  if(levelbox)
    delete levelbox;
	if(levellabel)
    delete levellabel;
	if(logbox)
    delete logbox;
	if(logline)
	  delete logline;
	if(loglabel)
    delete loglabel;
}

void OtherWidget::resizeEvent(QResizeEvent *re)
{
  QSize mainlblsize, recodeboxsize, levelboxsize, levellblsize, loglblsize, loglinesize;
  QWidget::resizeEvent(re);
  mainlblsize = mainlabel->sizeHint();
  mainlabel->setGeometry(10,10,mainlblsize.width(),mainlblsize.height());
  recodeboxsize = recodebox->sizeHint();
  recodebox->setGeometry(12,14+mainlblsize.height(),recodeboxsize.width(),recodeboxsize.height());
  logbox->setGeometry(7,19+mainlblsize.height()+recodeboxsize.height(),width()-13,height()-55);

	levellblsize = levellabel->sizeHint();
  levelboxsize = levelbox->sizeHint();
	loglblsize = loglabel->sizeHint();
	loglinesize = logline->sizeHint();
	int h = QMAX(QMAX(levellblsize.height(),levelboxsize.height()),
					QMAX(loglblsize.height(),loglinesize.height()));
	int w = QMAX(levellblsize.width(),loglblsize.width());
	levellabel->resize(w, h);
  levelbox->resize(width()-w-40,h);
	loglabel->resize(w, h);
	logline->resize(width()-w-40,h);
  int mh = (logbox->height()-20)/2;
	levellabel->move(15,logbox->y()+mh/2-h/2+15);
  levelbox->move(w+23,logbox->y()+mh/2-h/2+15);
	loglabel->move(15,logbox->y()+mh+mh/2-h/2+15);
	logline->move(w+23,logbox->y()+mh+mh/2-h/2+15);
}

void OtherWidget::setInfo(int rus, int lvl, const char *logname)
{
  recodebox->setChecked(rus);
	levelbox->setCurrentItem(lvl);
	logline->setText(logname);
}

int OtherWidget::rus()
{
  return recodebox->isChecked();
}

int OtherWidget::level()
{
  return levelbox->currentItem();
}

const char *OtherWidget::logfile()
{
  return logline->text();
}
