#ifndef _RECVWINDOW_
#define _RECVWINDOW_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <time.h>
#include <qpushbt.h>
#include <qgrpbox.h>
#include <qdialog.h>
#include <qlabel.h>
#include <qmlined.h>

class RecvWindow : public QDialog {
  Q_OBJECT
public:
  RecvWindow(const char*, unsigned long, const char*, time_t, const char*);
  ~RecvWindow();
  void setMessage(const char *);
  void setUIN(unsigned long);
  void setName(const char *);
  void setEMail(const char *);
  void setTime(time_t);
public slots:
  void closeBtn();
signals:
protected:
  unsigned long uin;
	QString nick;
	QString email;
  QPushButton *replybtn, *closebtn, *nextbtn, *addbtn;
  QGroupBox *frombox, *msgbox, *respbox;
  QLabel *uinlabel, *handlelabel, *emaillabel, *datelabel, *timelabel;
  QLabel *uinline, *handleline, *emailline, *dateline, *timeline;
  QPushButton *infobutton;
  QMultiLineEdit *msgedit;
  void resizeEvent(QResizeEvent *);
  void closeEvent(QCloseEvent *);
protected slots:
  void infoRequest();
  void addRequest();
	void replyRequest();
private:
private slots:
};
#endif /* _RECVWINDOW_ */
