#ifndef _USERITEM_
#define _USERITEM_

#include <qlistbox.h>
#include <qpainter.h>
#include <icq.h>

enum itType {tpOffSeparator, tpOnSeparator, tpNILSeparator, tpSystem, tpUser};
enum stUser {usOffline, usOnline, usNotInList};
enum stEvent {stEmpty, stMessage, stMessageLast, stURL, stURLLast};

typedef struct ContItem
{
  unsigned long uin;
  QString nick;
  QString firstName;
  QString lastName;
  QString email;
  unsigned long lastIp;
  QString city;
  QString state;
  QString zip;
  unsigned short country;
  char countryStat;
  QString homePage;
  unsigned char age;
  QString phone;
  unsigned char gender;
  QString about;
  QString notes;
  unsigned long status;
  unsigned char auth;
  ContItem()
	{
    uin = 0;
    nick = "N/A";
    firstName = "N/A";
    lastName = "N/A";
    email = "N/A";
		lastIp = 0;
		city = "N/A";
		state = "N/A";
		zip = "N/A";
		country = 0;
		countryStat = 0;
		homePage = "N/A";
		age = 0;
		phone = "N/A";
		gender = 0;
		about = "N/A";
		notes = "";
		status = (unsigned long)STATUS_OFFLINE;
		auth = 0;
	}
} ContactItem;

class UserItem : public QListBoxItem
{
public:
  UserItem(ContactItem item);
  UserItem(itType);
  UserItem(UserItem *);
  virtual void paint(QPainter *);
  itType type();
  unsigned long UIN();
  const char *name();
	const char *email();
	const char *first();
	const char *last();
  ContactItem getInfo();
	ContactItem *getInfoPtr();
  void setStatus(unsigned long);
  unsigned long getStatus();
protected:
  QPixmap pm_last;
	QPixmap pm_stat;
  ContactItem info;
  itType itype;
  virtual int height(const QListBox *) const;
  virtual int width(const QListBox *) const;
  virtual const QPixmap *pixmap_last();
  virtual const QPixmap *pixmap_stat();
private:
};
#endif
