#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>

#include "datatype.h"
#include "libicq.h"
#include "config.h"


extern unsigned long UIN;
extern char passwd[];
extern char server[];
extern unsigned long remote_port;
extern unsigned long set_status;

char icq_rc[100], contacts_rc[100];

#ifdef UNIX
/*******************************************************
Gets config info from the rc file in the users home 
directory.
********************************************************/
int Get_Config_Info()
{
   char path[300];

   strcpy(path, getenv("HOME"));
   strcat(path, "/.icq");
   mkdir(path, S_IRWXU);

   strcpy(icq_rc, path);
   strcat(icq_rc, "/icq.rc");
   
   strcpy(contacts_rc, path);
   strcat(contacts_rc, "/contacts.rc");

   if(!Read_ICQ_RC(icq_rc)) return 0;
   Read_Contacts_RC(contacts_rc);
   
   return 1;
}

#endif /* UNIX */

int Read_ICQ_RC(char* filename)
{
   FILE* fp;
   char buf[100], c;
   
   if(!(fp = fopen(filename, "rt")))
   {
      if(UIN == 0) return 0;
      
      set_status = STATUS_ONLINE;
      strcpy(server, "icq1.mirabilis.com");
      remote_port = 4000;

      Write_ICQ_RC(filename);
      return 1;
   }
   
   while(!feof(fp))
   {
      c = fgetc(fp);
      if(c == '#')
      {
         fgets(buf, 100, fp);
         continue;
      }
      else if(c == '\n')
      	continue;
      else
         ungetc(c, fp);

      fscanf(fp, "%s ", buf);
      
      if(!strcmp(buf, "UIN")) fscanf(fp, "%ld\n", &UIN);
      else if(!strcmp(buf, "Password")) fscanf(fp, "%s\n", passwd);
      else if(!strcmp(buf, "Status")) fscanf(fp, "%ld\n", &set_status);
      else if(!strcmp(buf, "Server")) fscanf(fp, "%s\n", server);
      else if(!strcmp(buf, "Port")) fscanf(fp, "%ld\n", &remote_port);
   }
   
   fclose(fp);

   return 1;
}


void Write_ICQ_RC(char* filename)
{
   FILE* fp;
printf("World\n");   
   if(!(fp = fopen(filename, "wt"))) return;
   
   fprintf(fp, "# ICQ connection settings\n\n");
   fprintf(fp, "UIN %ld\n", UIN);
   fprintf(fp, "Password %s\n", passwd);
   fprintf(fp, "Status %ld\n", set_status);
   fprintf(fp, "Server %s\n", server);
   fprintf(fp, "Port %ld\n", remote_port);
   
   fclose(fp);
}
   

int Read_Contacts_RC(char* filename)
{
   FILE* fp;
   char buf[100], c;

   Num_Contacts = 0;

   if(!(fp = fopen(filename, "rt"))) return 0;

   while(!feof(fp))
   {
      c = fgetc(fp);
      if(c == '#')
      {
         fgets(buf, 100, fp);
         continue;
      }
      else if(c == '\n')
      	continue;
      else
         ungetc(c, fp);
         
      fscanf(fp, "%ld ", &Contacts[Num_Contacts].uin);
      fgets(buf, 100, fp);
      buf[strlen(buf) - 1] = '\0';
      strncpy(Contacts[Num_Contacts].nick, buf, 20);
      Contacts[Num_Contacts].status = STATUS_OFFLINE;
      Contacts[Num_Contacts].last_time = -1L;
      Contacts[Num_Contacts].current_ip = -1L;
      Num_Contacts++;
   }
   
   fclose(fp);
   
   return 1;
}


void Write_Contacts_RC(char* filename)
{
   FILE* fp;
   int x;
   
   if(!(fp = fopen(filename, "wt"))) return;
   
   fprintf(fp, "# ICQ contact list\n\n");

   for(x = 0; x < Num_Contacts; x++)
      if((Contacts[x].uin > 0) && (strlen(Contacts[x].nick) > 0))
         fprintf(fp, "%ld %s\n", Contacts[x].uin, Contacts[x].nick);
   
   fclose(fp);
}
