/*********************************************
**********************************************
This is the main ICQ file. Currently it
logs in and sits in a loop. It can receive
messages and keeps the connection alive.
Use crtl-break to exit.

This software is provided AS IS to be used in
whatever way you see fit and is placed in the
public domain.

Author : Matthew Smith April 19, 1998
Contributors : Nicolas Sahlqvist April 27, 1998
			   Ulf Hedlund (guru@slideware.com) April 28, 1998
            Michael Ivey May 4, 1998
            Michael Holzt May 5, 1998

Changes :
   4-28-98 support for WIN32 [UH]
   4-20-98 added variable time_delay between keep_alive packets mds
   4-20-98 added instant message from server support mds
   4-21-98 changed so that long ( 250+ characters ) messages work
            new maximum is ~900 which is hopefully big enough.
            When I know more about udp maybe I can come up with
            a general solution. mds I now think ICQ has a max that is
            smaller than this so everything is ok mds I now think that
            the icq client's maximum is arbitrary and can be ignored :)
   4-23-98 Added beginnings of a user interface
   4-26-98 Changed the version to 0.2a :)
   4-27-98 Nicco added feature to use nick names to log in
   5-05-98 Authorization Messages
   5-13-98 Added time stamps for most things.
   6-17-98 Changed condition on which we should send auto_reply message. Fryslan
   6-18-98 Added different auto reply messages for different status types see also ui.c and util.c Fryslan
   6-20-98 Added an alter command to alter your command names online. Fryslan
**********************************************
**********************************************/
#ifdef _WIN32
#include <conio.h>
#include <io.h>
#include <winsock2.h>
#include <time.h>
#else
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <assert.h>

#include "datatype.h"
#include "icq.h"
#include "libicq.h"
#include "send.h"
#include "receive.h"
#include "util.h"
#include "config.h"


BOOL Russian = FALSE;
BOOL Logging = TRUE;
BOOL Quit = FALSE;
BOOL Verbose = FALSE; /* this is needed because I leeched so code 
                  from another project I'm working on. */
BOOL serv_mess[ 1024 ];
WORD last_cmd[ 1024 ]; /* command issued for the first 1024 SEQ #'s */
/******************** if we have more than 1024 SEQ this will need some hacking */
WORD seq_num = 1;  /* current sequence number */
DWORD our_ip = 0x0100007f; /* localhost for some reason */
DWORD our_port; /* the port to make tcp connections on */
/************ We don't make tcp connections yet though :( */
DWORD UIN = 0; /* current User Id Number */
BOOL Contact_List = FALSE;
Contact_Member Contacts[ 100 ]; /* no more than 100 contacts max */
int Num_Contacts;
DWORD Current_Status=STATUS_OFFLINE;
SEARCH_RESULT* Search_Results;
DWORD last_recv_uin=0;
char passwd[100];
char server[100];
DWORD set_status;
DWORD remote_port;
BOOL Done_Login=FALSE;
SOK_T sok;

extern char contacts_rc[100];

int ICQ_Connect()
{
#ifdef _WIN32
   WSADATA wsaData;

   if(!WSAStartup( 0x0101, &wsaData ))
   {
      perror("Sorry, can't initialize Windows Sockets...");
      exit(1);
   }
#endif /* _WIN32 */

   Search_Results = NULL;
   Verbose = 0;
   if(Get_Config_Info() == 0) return 0;;
   Connect_Remote(server, remote_port);
   Send_BeginLogin(UIN, &passwd[0], our_ip, our_port);

   return 1;
}


void ICQ_Disconnect()
{
   Send_Disconnect();
}


void ICQ_Change_Status(int new_status)
{
   Send_ChangeStatus(new_status);
}


void ICQ_Keep_Alive()
{
   Send_KeepAlive();
}


void ICQ_Check_Response(long timeout)
{
   struct timeval tv;
   fd_set readfds;

   tv.tv_sec = 0;
   tv.tv_usec = timeout;

   FD_ZERO(&readfds);
   FD_SET(sok, &readfds);
#ifndef _WIN32
   FD_SET(STDIN, &readfds);
#endif /* _WIN32 */

   /* don't care about writefds and exceptfds: */
   select(sok + 1, &readfds, NULL, NULL, &tv);

   if(FD_ISSET(sok, &readfds))
      Handle_Server_Response();
}


void ICQ_Register_Callback(int type, CALLBACK func)
{
   event[type] = func;
}


void ICQ_Send_Message(long uin, char* text)
{
   Send_Message(uin, text);
}


void ICQ_Send_URL(long uin, char* url, char* text)
{
   Send_URL(uin, url, text);
}

void ICQ_Search(char *email, char *nick, char* first, char* last)
{
   Send_SearchRequest(email, nick, first, last);
}


void ICQ_Get_Info(long uin)
{
   Send_InfoRequest(uin);
}


void ICQ_Get_Ext_Info(long uin)
{
   Send_ExtInfoRequest(uin);
}


void ICQ_Add_User(long uin, char *name)
{
   Contacts[ Num_Contacts ].uin = uin;
   Contacts[ Num_Contacts ].status = STATUS_OFFLINE;
   Contacts[ Num_Contacts ].last_time = -1L;
   Contacts[ Num_Contacts ].current_ip = -1L;
   Contacts[ Num_Contacts ].port = 0;
   Contacts[ Num_Contacts ].sok = (SOK_T ) -1L;
   memcpy( Contacts[ Num_Contacts ].nick, name, sizeof( Contacts->nick )  );
   Num_Contacts++;
   Send_ContactList();
   
   Write_Contacts_RC(contacts_rc);
}


void ICQ_Rename_User(long uin, char *name)
{
   int x;
  
   for(x = 0; x < Num_Contacts; x++)
      if(Contacts[x].uin == uin) break;
      
   if(x >= Num_Contacts) return;
   
   memcpy(Contacts[x].nick, name, sizeof(Contacts->nick));
   Write_Contacts_RC(contacts_rc);
}


void ICQ_Delete_User(long uin)
{
   int x;
  
   for(x = 0; x < Num_Contacts; x++)
      if(Contacts[x].uin == uin) break;
      
   if(x >= Num_Contacts) return;
   
   Contacts[x].uin = 0;
   Write_Contacts_RC(contacts_rc);
}




