/*********************************************
**********************************************
This file has the "ui" functions that read input
and send messages etc.

This software is provided AS IS to be used in
whatever way you see fit and is placed in the
public domain.


Used/Changed for zICQ by Zack Allison, June 1998

Author : Matthew Smith April 23, 1998
Contributors : Nicolas Sahlqvist April 27, 1998
               Michael Ivey May 4, 1998
               Ulf Hedlund -- Windows Support
               Michael Holzt May 5, 1998
Changes :
**********************************************
**********************************************/

#include "zicq.h"
#include "datatype.h"
#include <stdio.h>
#include <stdlib.h>
#ifdef _WIN32
  #include <winsock2.h>
#else
  #include <unistd.h>
  #include <netinet/in.h>
  #include <sys/types.h>
  #include <sys/stat.h>
  #include <sys/time.h>
  #include <sys/socket.h>
  #include <arpa/inet.h>
  #include <netdb.h>
#endif
#include <fcntl.h>
#include <time.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <assert.h>
//#include <strstream.h>

static DWORD last_uin=0; // No one's messaged us yet.
static DWORD multi_uin;
static void Show_Status( void );
int status;

#define UIN_DELIMS ":|/ " /* add space if you don't want your nick names to have spaces */
#define END_MSG_STR "."
#define CANCEL_MSG_STR "#"
#define W_SEPERATOR MESSCOL "=============" NOCOL "\n"

BOOL Do_Multiline( SOK_T sok, char *buf ) // run when we got to "multiline mode"
{
   static int offset=0;
   static char msg[1024];
   FD_T fdtmp;

wcolor_set(statz,1,NULL);
           lw_wprintw(statz,"\n\nNow in Multi-Line mode to "); // Tell the user who they're
           wcolor_set(statz,4,NULL);			    // talking to
           lw_wprintw(statz,"%s ",Get_Nick(multi_uin));
           wcolor_set(statz,1,NULL);
           lw_wprintw(statz,"(");
           wcolor_set(statz,4,NULL);
           lw_wprintw(statz,"%ld",multi_uin);
           wcolor_set(statz,1,NULL);
           lw_wprintw(statz,")");
           wcolor_set(statz,1,NULL);

   wrefresh(statz);
  
   msg[ offset ] = 0;
   if ( ! strcmp( buf, END_MSG_STR ) )
   {
	char hbuffer[1024];
	time_t htimeval;

      icq_sendmsg( sok, multi_uin, msg );
      wcolor_set(mainw,1,NULL);
      lw_wprintw(mainw,"\nTo: ");
      wcolor_set(mainw,4,NULL);
      lw_wprintw(mainw,"%s",Get_Nick(multi_uin));
      wcolor_set(mainw,1,NULL);
      rus_conv ("wk",msg);
	// Farquin tmp files due to lw_wprintw limitations
	// Dumps it to a file, then re-reads it
     if(( fdtmp = fopen(".zicqtmp", "w") ) == (FILE *) NULL ){
           lw_wprintw(mainw, "ERROR: Can't make tmp files.\n",
                           ".zicqtmp");
          goto zdone3; // I hate gotos
     }
   fprintf(fdtmp, "\n%s\n",line_wrap(mainw,&msg,0));
   fclose(fdtmp);


      fdtmp = open ( ".zicqtmp", O_RDONLY );
           if (fdtmp == -1) {
                lw_wprintw(mainw,"ERROR: Can't read tmp files.\n");
                goto zdone3;
           }
        lw_wprintw(mainw,"\n");
        for ( ; ! M_fdnreadln( fdtmp, hbuffer, sizeof( hbuffer ) ); ) {
                lw_wprintw(mainw,"%s\n",hbuffer);
           }
      close(fdtmp);
      remove( ".zicqtmp" );
      //wprintw(mainw,"\n%s\n",data);
      wrefresh(mainw);
    zdone3:
   

      lw_wprintw(mainw, "Message sent!\n" );
      last_uin = multi_uin;
      offset = 0;
      return FALSE;
   }
   else if ( ! strcmp( buf, CANCEL_MSG_STR ) )
   {
      lw_wprintw(mainw, "Message canceled!\n" );
      last_uin = multi_uin;
      offset = 0;
      return FALSE;
   }
   else
   {
      if ( offset + strlen( buf ) < 1024 )
      {
         strcat( msg, buf );
         strcat( msg, "\r\n" );
         offset += strlen( buf ) + 2;
         return TRUE;
      }
      else
      { // Never seen this executed.
         lw_wprintw(mainw, "Message sent before last line buffer is full\n" );
         icq_sendmsg( sok, multi_uin, msg );
         last_uin = multi_uin;
         offset = 0;
         return FALSE;
      }
   }
}

BOOL Do_Multiline_All( SOK_T sok, char *buf ) // Sending a long message
{					     // To everyone on the list
   static int offset=0;
   static char msg[1024];
   int i;
   
   msg[ offset ] = 0;
   if ( ! strcmp( buf, END_MSG_STR ) )
   {
      for ( i=0; i < Num_Contacts; i++ )
         icq_sendmsg( sok, Contacts[i].uin, msg );
      lw_wprintw(mainw,"To: %s\n%s\n","EVERYONE",msg);
      lw_wprintw(mainw, "Message sent!\n" );
      offset = 0;
      return FALSE;
   }
   else if ( ! strcmp( buf, CANCEL_MSG_STR ) )
   {
      lw_wprintw(mainw, "Message canceled!\n" );
      offset = 0;
      return FALSE;
   }
   else
   {
      if ( offset + strlen( buf ) < 1024 )
      {
         strcat( msg, buf );
         strcat( msg, "\r\n" );
         offset += strlen( buf ) + 2;
         return TRUE;
      }
      else
      {
         lw_wprintw(mainw, "Message sent before last line buffer is full\n" );
         for ( i=0; i < Num_Contacts; i++ )
            icq_sendmsg( sok, Contacts[i].uin, msg );
         offset = 0;
         return FALSE;
      }
   }
}

/******************************************************
Read a line of input and processes it.
*******************************************************/
void Get_Input( SOK_T sok )
{
   char buf[1024]; /* This is hopefully enough. Added more, ZA */
   char *cmd; // The command
   char *arg1; // First argument (eventually)
  // static status = 0;
   DWORD uin;
   echo(); // Show 'em what they're typing.  ncurses.h
   raw(); // don't grab key stroke. ncurses.h
   memset( buf, 0, 1024 ); // allocate memory
   wcolor_set(userin,2,NULL);
   lw_wprintw(userin,"\n\n\n\nZicq> "); //prompt, shown when a key is pressed
   wcolor_set(userin,1,NULL);
   wrefresh(userin);
   Show_Quick_Status();
   wgetnstr(userin,&buf,1023); // Gets the string, 1023 bytes.
   waddstr(userin,"\n\n\n\n");
   buf[1023]=0; /* be safe */
   if ( status == 1 )
   {
      if ( ! Do_Multiline( sok, buf ) ) // Are we doing multiline?
      {
         status = 2;
      } else {
	   wcolor_set(statz,1,NULL);
	   lw_wprintw(statz,"\n\nNow in Multi-Line mode to ");
	   wcolor_set(statz,4,NULL);
	   lw_wprintw(statz,"%s ",Get_Nick(multi_uin));
	   wcolor_set(statz,1,NULL);
	   lw_wprintw(statz,"(");
	   wcolor_set(statz,4,NULL);
	   lw_wprintw(statz,"%ld",multi_uin);
	   wcolor_set(statz,1,NULL);
	   lw_wprintw(statz,")");
	   wcolor_set(statz,1,NULL);
	   fflush(stdout);
   	}
   }
   else if ( status == 3 )
   {
      if ( ! Do_Multiline_All( sok, buf ) ) // Multi-to Everyone?
      {
         status = 2;
      } else {
	   printf ( "msg all> ");
	   fflush(stdout);
   	}
   }
   else
   {
      if ( buf[0] != 0 )
      {
         cmd = strtok( buf, " \n\t" );
         if ( cmd == NULL )
            goto done;  /* ARRRGGGGHHHH!!!! I hate gotos */
         if ( ( ! strcasecmp( cmd , "quit" ) ) ||
              ( ! strcasecmp( cmd , "/quit" ) ) )
         {
            Quit = TRUE;
         }
         else if ( ! strcasecmp( cmd, quit_cmd ) )
         {
            Quit = TRUE;
         }
         else if ( ! strcasecmp( cmd, change_cmd ) )
         {
            arg1 = strtok( NULL, " \n\r" );
            if ( arg1 == NULL )
            {
               lw_wprintw(mainw,  CLIENTCOL "Status modes: \n" );
               lw_wprintw(mainw, "Status online         %d\n", STATUS_ONLINE );
               lw_wprintw(mainw, "Status Away           %d\n", STATUS_AWAY );
               lw_wprintw(mainw, "Status Do not Disturb %d\n", STATUS_DND );
               lw_wprintw(mainw, "Status Not Available  %d\n", STATUS_NA );
               lw_wprintw(mainw, "Status Free for Chat  %d\n", STATUS_FREE_CHAT );
               lw_wprintw(mainw, "Status Occupied       %d\n", STATUS_OCCUPIED );
               lw_wprintw(mainw, "Status Not Available  %d\n", STATUS_NA );
               lw_wprintw(mainw, "Status Invisible      %d\n", STATUS_INVISIBLE );
               lw_wprintw(mainw, NOCOL "\n" );
            }
            else
            {
               icq_change_status( sok, atoi( arg1 ) );
	       waddstr(statz,"\nCurrent Stat: "); 
		wrefresh(statz);
              Print_Status(statz, Current_Status );
               lw_wprintw(mainw, "\n" );
		Show_Quick_Status();
            }
         }
              else if ( ! strcasecmp( cmd, "sound" ) ) /* Toggle Sound */
              {
                Dosound = (Dosound == FALSE);
                lw_wprintw(mainw,"\nSound now set to %s\n",Dosound ? "On" : "Off" );
              }
	      else if ( ! strcasecmp( cmd, "beep" ) ) /* Toggle BEEP */
	      {
		Dobeep = (Dobeep == FALSE);
		lw_wprintw(mainw,"\nBeep now set to %s\n",Dobeep ? "On" : "Off" );
	      }
	      else if ( ! strcasecmp( cmd, online_cmd ) ) /* online command */
	      {
	          icq_change_status( sok, STATUS_ONLINE );
             	  //Print_Status(statz, Current_Status );
		  Show_Quick_Status();
             lw_wprintw(mainw, "\n" );
	      }
	      else if ( ! strcasecmp( cmd, away_cmd ) ) /* away command */
	      {
	          icq_change_status( sok, STATUS_AWAY );
             Print_Status(statz, Current_Status );
             lw_wprintw(mainw, "\n" );
	      }
	      else if ( ! strcasecmp( cmd, na_cmd ) ) /* Not Available command */
	      {
	          icq_change_status( sok, STATUS_NA );
             Print_Status(statz, Current_Status );
             lw_wprintw(mainw, "\n" );
	      }
	      else if ( ! strcasecmp( cmd, occ_cmd ) ) /* Occupied command */
	      {
	          icq_change_status( sok, STATUS_OCCUPIED );
             Print_Status(statz, Current_Status );
             lw_wprintw(mainw, "\n" );
	      }
	      else if ( ! strcasecmp( cmd, dnd_cmd ) ) /* Do not Disturb  command */
	      {
	          icq_change_status( sok, STATUS_DND );
             Print_Status(statz, Current_Status );
             lw_wprintw(mainw, "\n" );
	      }
	      else if ( ! strcasecmp( cmd, ffc_cmd ) ) /* Free For Chat command */
	      {
	          icq_change_status( sok, STATUS_FREE_CHAT );
             Print_Status(statz, Current_Status );
             lw_wprintw(mainw, "\n" );
	      }
	      else if ( ! strcasecmp( cmd, inv_cmd ) ) /* Invisible command */
	      {
	          icq_change_status( sok, STATUS_INVISIBLE );
             Print_Status(statz, Current_Status );
             lw_wprintw(mainw, "\n" );
	      }
	      else if ( ! strcasecmp( cmd, search_cmd ) ) // Search based on email
	      {
             arg1 = strtok( NULL, "\n" );
             if ( arg1 == NULL )
             {
               lw_wprintw(mainw,"Must enter email address.\n");
             }
             else
             {
   	          start_search( sok, arg1, "", "", "" );
             }
	      }
         else if ( ! strcasecmp( cmd, status_cmd ) ) // Full status.
         {
            Show_Status();
         }
         else if ( ! strcasecmp( cmd, list_cmd ) ) // Quick Status, list box
         {
            Show_Quick_Status();
         }
         else if ( ! strcasecmp( cmd, "msga" ) ) // Message everyone!
         {
            status = 3;
            lw_wprintw(mainw, "msg all> " );
            fflush(stdout);
         }
         else if ( ! strcasecmp( cmd, reply_cmd ) ) /* reply command */
         {
            if ( last_recv_uin == 0 )
            {
               lw_wprintw(mainw, "Must receive a message first\n" );
               goto done;
            }
            arg1 = strtok( NULL, "" );
            last_uin = last_recv_uin;
            if ( arg1 != NULL )
            {
               icq_sendmsg( sok, last_recv_uin, arg1 );
		wcolor_set(mainw,1,NULL);
		wprintw(mainw,"To ");
		wcolor_set(mainw,4,NULL);
		wprintw(mainw,"%s",Get_Nick(last_recv_uin));
		wcolor_set(mainw,1,NULL);
		lw_wprintw(mainw,": %s\n",arg1);
            }
            else
            {
	       wcolor_set(statz,1,NULL);
               lw_wprintw(statz,"\n\nNow in Multi-Line mode to ");
           wcolor_set(statz,4,NULL);
           lw_wprintw(statz,"%s ",Get_Nick(last_recv_uin));
           wcolor_set(statz,1,NULL);
           lw_wprintw(statz,"(");
           wcolor_set(statz,4,NULL);
           lw_wprintw(statz,"%ld",last_recv_uin);
           wcolor_set(statz,1,NULL);
           lw_wprintw(statz,")");
           wcolor_set(statz,1,NULL);

               status = 1;
            }
         }
         else if ( ! strcasecmp( cmd, "resize") ) /* resize: Works now.    */
					  /* use when you change yer screen*/
					  /* size. (Xterm,etc) */
         {
		resize();
		wprintw(mainw,"Resized to %ix%i\n",LINES,COLS);
		if (has_colors()) {
			wcolor_set(mainw,2,NULL);
			wprintw(mainw,"Term supports Color.\n");
			wcolor_set(mainw,1,NULL);
		} else {
			wprintw(mainw,"Term does NOT support color :(\n");
		}
		Show_Quick_Status();
	 }
	 else if ( ! strcasecmp( cmd, "url" ) ) /* send a url. */
	 {
	 char* desc;
	 char* data;
	 char* arg2;
         DWORD uuin;
	 int err=0;

	 arg1 = strtok (NULL, ""); // Gets the rest of the command, and parses it
	 if ( arg1 != NULL ) {
	   arg2 = strsep( &arg1, " ");
	   if ((arg2 != NULL ) && (arg1 !=NULL)) {
	    if (nick2uin( arg2 ) != -1) {
   	     data = strsep( &arg1, " ");   
             if (( data != NULL ) && (arg1 !=NULL)) {
	      desc = arg1;
	      uuin = (DWORD) nick2uin( arg2 );
	      icq_sendurl(sok, (DWORD) uuin, desc,data);
	      wcolor_set(mainw,1,NULL);
	      lw_wprintw(mainw,"Sent URL to ");
	      wcolor_set(mainw,4,NULL);
	      lw_wprintw(mainw,"%s",Get_Nick(uuin));
	      wcolor_set(mainw,1,NULL);
	      lw_wprintw(mainw,"(");
	      wcolor_set(mainw,4,NULL);
	      lw_wprintw(mainw,"%ld",uuin);
	      wcolor_set(mainw,1,NULL);
	      lw_wprintw(mainw,")\n       URL: ");
	      lw_wprintw(mainw,"%s\n",data);
	      lw_wprintw(mainw,"Decription: ");
	      lw_wprintw(mainw,"%s\n",desc);
	      goto zdone5; // I HATE GOTOS!!!!
	     }
	   }
	  }
	  err = 1;
         }
	 if (err = 1) { // did they screw up?
		wprintw(mainw,"No such user: %s\n",arg2);
	 } else {
	 	wprintw(mainw,"\nToo few arguments: url <nick> <url> <description>\n");
	 	zdone5:
	 }
	}
       else if ( ! strcasecmp( cmd, "spoof") ) /* my spoof command: launches external program.*/
	 {					/* if you can't figure this out, you don't need */
	 char* arg2;			       /* to use it. */
	 char* spoofuin;
	 char* mess;
	 char cmd2[300];
	 DWORD theip;
	 DWORD theiruin;
	 DWORD theport;

	 arg1 = strtok( NULL, "" );
	 arg2 = strsep( &arg1, " ");
	 spoofuin = strsep ( &arg1, " ");
	 mess = arg1;

	 theiruin = nick2uin ( arg2 );
	 theip = Get_IP( theiruin );
	 theport = Get_Port( theiruin );
	 sprintf( &cmd2, "icqspoof %u.%u.%u.%u %s \"%s\" %ld %ld > /dev/null &",(BYTE)(theip>>24),(BYTE) (theip>>16),(BYTE)(theip>>8),(BYTE) theip,spoofuin,mess,theport,theport);
	 system(&cmd2);
	 sprintf( &cmd2, "\nSpoofed to: %ld from %s said: %s\n",theiruin,spoofuin,mess);
	 lw_wprintw(mainw,&cmd2);
	 
	 }

         else if ( ! strcasecmp( cmd, again_cmd ) ) /* again command */
						    /* msg to same person, AGAIN */
         {
            if ( last_uin == 0 )
            {
               lw_wprintw(mainw, "Must write one message first\n" );
               goto done;
            }
            arg1 = strtok( NULL, "" );
            if ( arg1 != NULL )
            {
               icq_sendmsg( sok, last_uin, arg1 );
	       wcolor_set(mainw,1,NULL);
               lw_wprintw(mainw,"\nTo ");
	       wcolor_set(mainw,4,NULL);
	       lw_wprintw(mainw,"%s",Get_Nick(last_uin));
	       wcolor_set(mainw,1,NULL);
	       lw_wprintw(mainw,": %s\n",arg1);
            }
            else
            { 
               status = 1;
wcolor_set(statz,1,NULL);
           lw_wprintw(statz,"\n\nNow in Multi-Line mode to ");
           wcolor_set(statz,4,NULL);
           lw_wprintw(statz,"%s ",Get_Nick(last_uin));
           wcolor_set(statz,1,NULL);
           lw_wprintw(statz,"(");
           wcolor_set(statz,4,NULL);
           lw_wprintw(statz,"%ld",last_uin);
           wcolor_set(statz,1,NULL);
           lw_wprintw(statz,")");
           wcolor_set(statz,1,NULL);

               fflush(stdout);
            }
         }
         else if ( ! strcasecmp( cmd, "clear")) // Clears the mainwindow
   	   {
      	 	clrscr();
      		goto done;
      	}
         else if ( ! strcasecmp( cmd, info_cmd ) ) // Get info from the server
         {
            arg1 = strtok( NULL, "" );
            if ( arg1 == NULL )
            {
               lw_wprintw(mainw, "Need uin to get info on\n" );
               goto done; /* sorry */
            }
            uin = nick2uin( arg1 );
            if ( -1 == uin )
            {
               lw_wprintw(mainw, "%s not recognized as a nick name\n", arg1 );
               goto done;
            }
            lw_wprintw(mainw, "%s's IP address is ", arg1 );
            Print_IP( uin );
            lw_wprintw(mainw, "\tThe port is %d\n",(WORD) Get_Port( uin ) );
            lw_wprintw(mainw, "\n" );
            send_info_req( sok, uin );
         }
         else if ( ! strcasecmp( cmd, add_cmd ) ) //add a new user to yer list
         {
            arg1 = strtok( NULL, " \t" );
            if ( arg1 != NULL )
            {
               uin = atoi( arg1 );
               arg1 = strtok( NULL, "" );
               if ( arg1 != NULL )
               {
                  Add_User( sok, uin, arg1 );
                  lw_wprintw(mainw, "%s added.\n", arg1 );
               }
            }
            else
            {
               lw_wprintw(mainw, SERVCOL "Must specify a nick name" NOCOL "\n" );
            }
         }
	 else if ( ! strcasecmp( cmd, "hist" ) ) // Show history [of user]
	 {
	     FD_T   *fdhist;
   	     char    hbuffer[1024];
  	     time_t  htimeval;
  	     char *hpath;
  	     char hbuf[1024];
	     char htmp[20];
	     cmd = strtok( NULL, "" );

	   if ( ! Logging )
	      return ;

#ifdef _WIN32
   	hpath = ".\\";
#endif

#ifdef UNIX
   	hpath = getenv( "HOME" );
#endif

#ifdef __amigaos__
   	hpath = "PROGDIR:";
#endif
	   strcpy( hbuffer, hpath );
	   if ( cmd == NULL ) {
		strcat(hbuffer,"/.zicq/zicq_log");
	   } else {
		if (nick2uin(cmd) == -1) {
			wprintw(mainw,"Not a valid name: %s\n",cmd);
			goto zdone;
		}
		sprintf(&htmp,"/.zicq/.zicq-%ld",nick2uin(cmd));
		strcat(hbuffer,&htmp);
	   }

	   fdhist = open ( hbuffer, O_RDONLY );
           if (fdhist == -1) {
		wprintw(mainw,"No history found or could not be read.\n");
		goto zdone;
	   }
	   lw_wprintw(mainw,"=== History from %s ===\n",hbuffer);
	   for ( ; ! M_fdnreadln( fdhist, hbuf, sizeof( hbuf ) ); ) {
		wprintw(mainw,"%s\n",hbuf);
	   }
	   lw_wprintw(mainw,"=== End of History ===\n");
	   close(fdhist);
	   zdone:
	 }
	 else if ( ! strcasecmp( cmd, "iinfo" ) )
	 {
	    arg1 = strtok( NULL, "" );
            if ( arg1 == NULL )
            {
               lw_wprintw(mainw, "Need uin to get info on\n" );
               goto done; /* sorry */
            }
            uin = nick2uin( arg1 );
            if ( -1 == uin )
            {
               lw_wprintw(mainw, "%s not recognized as a nick name\n", arg1 );
               goto done;
            }
	  Print_UIN_Name( uin );
	  lw_wprintw (mainw, "'s (");
	  lw_wprintw (mainw, "%ld", uin );
	  lw_wprintw (mainw, ") IP address is " );
	  Print_IP( uin );
	  lw_wprintw (mainw, "  The port is %d\n", (WORD) Get_Port( uin ) );
	  lw_wprintw (mainw, "\n" );
	 }
         else if ( ! strcasecmp( cmd, "rinfo" ) )
         {
	    arg1 = strtok( NULL, "" );
            if ( arg1 == NULL )
            {
               lw_wprintw(mainw, "Need uin to get info on\n" );
               goto done; /* sorry */
            }
            uin = nick2uin( arg1 );
            if ( -1 == uin )
            {
               lw_wprintw(mainw, "%s not recognized as a nick name\n", arg1 );
               goto done;
            }

            Print_UIN_Name( uin );
            lw_wprintw(mainw, "'s IP address is " );
            Print_IP( uin );
            lw_wprintw(mainw, "\tThe port is %d\n",(WORD) Get_Port( uin ) );
            lw_wprintw(mainw, "\n" );
            send_info_req( sok, last_recv_uin );
         }
         else if ( ( ! strcasecmp( cmd, "/help" ) ) || 
                   ( ! strcasecmp( cmd, "help" ) ) ) // Ugly help command. TODO
         {
            lw_wprintw(mainw, MESSCOL "%s" NOCOL"\t\tDisplays your autoreply status\n",auto_cmd );
            lw_wprintw(mainw, MESSCOL "%s [on|off]" NOCOL "\tToggles sending messages when your status is DND, NA, etc.\n",auto_cmd );
            lw_wprintw(mainw, MESSCOL "%s message" NOCOL "\tSets the message to send as an auto reply\n",auto_cmd );
            lw_wprintw(mainw, MESSCOL "%s" NOCOL "\t\tDisplays the current status of everyone on your contact list\n",list_cmd);
            lw_wprintw(mainw, MESSCOL "%s [#]" NOCOL "\tChanges your status to the status number.\n\t\tWithout a number it lists the available modes.\n",change_cmd);
            lw_wprintw(mainw, MESSCOL "%s uin" NOCOL "\t Displays general info on uin\n", info_cmd );
            lw_wprintw(mainw, MESSCOL "add uin nick" NOCOL "\tAdds the uin number to your contact list with nickname.\n" );
            lw_wprintw(mainw, MESSCOL "clear" NOCOL "\t\tClears the screen.\n" );
            lw_wprintw(mainw, MESSCOL "%s email@host" NOCOL "\tSearches for a ICQ user with the specified email address.\n", search_cmd );
	         lw_wprintw(mainw, MESSCOL "%s" NOCOL "\t\tMark as Online.\n",online_cmd);
	         lw_wprintw(mainw, MESSCOL "%s" NOCOL "\t\tMark as Away.\n",away_cmd);
            lw_wprintw(mainw, MESSCOL "%s" NOCOL "\t\tMark as Not Available.\n",na_cmd);
            lw_wprintw(mainw, MESSCOL "%s" NOCOL "\t\tMark as Occupied.\n",occ_cmd);
            lw_wprintw(mainw, MESSCOL "%s" NOCOL "\t\tMark as Do not Disturb.\n",dnd_cmd);
            lw_wprintw(mainw, MESSCOL "%s" NOCOL "\t\tMark as Free for Chat.\n",ffc_cmd);
            lw_wprintw(mainw, MESSCOL "%s" NOCOL "\t\tMark as Invisible.\n",inv_cmd);
            lw_wprintw(mainw, MESSCOL "%s\t" NOCOL "\tLogs off and quits\n",quit_cmd );
            lw_wprintw(mainw, MESSCOL "msga\t\t" NOCOL "Sends a multiline message to everyone on your list.\n" );
            lw_wprintw(mainw, MESSCOL "%s uin\t" NOCOL "Authorize uin to add you to their list\n", auth_cmd );
            lw_wprintw(mainw, MESSCOL "%s uin/message" NOCOL "\tSends a message to uin\n", message_cmd );
            lw_wprintw(mainw, MESSCOL "%s message" NOCOL "\tSends a message to the last person you sent a message to\n", again_cmd);
            lw_wprintw(mainw, MESSCOL "%s message" NOCOL "\tReplys to the last person to send you a message\n", reply_cmd);
            lw_wprintw(mainw, CLIENTCOL "\tSending a blank message will put the client into multiline mode.\n\tUse . on a line by itself to end message." NOCOL "\n" );
         }
         else if ( ! strcasecmp( cmd, auth_cmd ) ) // Authorize a user
         {
             arg1 = strtok( NULL, "" );
             if ( arg1 == NULL )
             {
                lw_wprintw(mainw, "Need uin to send to\n" );
                goto done; /* sorry */
             }
             uin = nick2uin( arg1 );
             if ( -1 == uin )
             {
                lw_wprintw(mainw, "%s not recognized as a nick name\n", arg1 );
                goto done;
             }
             icq_sendauthmsg( sok, uin );
         }
         else if ( ! strcasecmp( cmd, message_cmd ) ) /* send a message */
         {
            arg1 = strtok( NULL, UIN_DELIMS );
            if ( arg1 == NULL )
            {
               lw_wprintw(mainw, "Need uin to send to\n" );
               goto done; /* sorry */
            }
            uin = nick2uin( arg1 );
            if ( -1 == uin )
            {
               lw_wprintw(mainw, "%s not recognized as a nick name\n", arg1 );
               goto done;
            }
            arg1 = strtok( NULL, "" );
            last_uin = uin;
            if ( arg1 != NULL )
            {
               icq_sendmsg( sok, uin, arg1 );
	       wcolor_set(mainw,1,NULL);
	       lw_wprintw(mainw,"\nTo ");
	       wcolor_set(mainw,4,NULL);
	       lw_wprintw(mainw,"%s",Get_Nick(uin));
   	       wcolor_set(mainw,1,NULL);
	       lw_wprintw(mainw,": %s\n",arg1);
            }
            else
            {
               status = 1;
wcolor_set(statz,1,NULL);
           lw_wprintw(statz,"\n\nNow in Multi-Line mode to ");
           wcolor_set(statz,4,NULL);
           lw_wprintw(statz,"%s ",Get_Nick(multi_uin));
           wcolor_set(statz,1,NULL);
           lw_wprintw(statz,"(");
           wcolor_set(statz,4,NULL);
           lw_wprintw(statz,"%ld",multi_uin);
           wcolor_set(statz,1,NULL);
           lw_wprintw(statz,")");
           wcolor_set(statz,1,NULL);
	       wrefresh(statz);
               fflush(stdout);
            }
         }
         else if ( ! strcasecmp( cmd, "auto" ) ) // Automatic replies
         {
            cmd = strtok( NULL, "" );
            if ( cmd == NULL )
            {
               lw_wprintw(mainw, "Automatic replies are %s\n", auto_resp ? "On" : "Off" );
               lw_wprintw(mainw, "The message is: \n%s\n", auto_rep_str );
               goto done;
            }
            if ( ! strcasecmp( cmd, "on" ) )
            {
               auto_resp = TRUE;
               lw_wprintw(mainw, "Automatic replies are on.\n" );
            }
            else if ( ! strcasecmp( cmd, "off" ) )
            {
               auto_resp = FALSE;
               lw_wprintw(mainw, "Automatic replies are off.\n" );
            }
            else
            {
               lw_wprintw(mainw, "Automatic reply set\n" );
               strcpy( auto_rep_str, cmd );
            }
         }
         else 
         {
            lw_wprintw(mainw, "Unknown command %s, type /help for help.\n", cmd );
         }
         done:  /* sorry I hate goto's also */
	     ;
      }
   }
   multi_uin = last_uin;
   if ( ( status != 1 ) && ( status != 3) )
   {
      if ( ! Quit )
         Prompt();
   }
}

static void Show_Status( void ) // Show lots of information
{
   int i;
   lw_wprintw(statz, "Your status is " );
   Print_Status(statz, Current_Status );
   lw_wprintw(statz,"\tLast: ");
   lw_wprintw(statz,"%s\t",Get_Nick(last_recv_uin));
   lw_wprintw(statz,"Again: ");
   lw_wprintw(statz,"%s",Get_Nick(last_uin));
   wrefresh(statz);
   lw_wprintw(mainw, "\n" );
   /*  First loop sorts thru all offline users */
   for ( i=0; i< Num_Contacts; i++ )
   {
      if ( ( S_DWORD )Contacts[ i ].uin > 0 )
      {
         if ( Contacts[ i ].status == STATUS_OFFLINE )
         {
	    wcolor_set(mainw,4,NULL);
            lw_wprintw(mainw, "%8ld", Contacts[ i ].uin ); 
	    wcolor_set(mainw,1,NULL);
	    lw_wprintw(mainw, " = ");
	    wcolor_set(mainw,4,NULL);
            lw_wprintw(mainw, "%-8s", Contacts[ i ].nick );
	    wcolor_set(mainw,1,NULL);
            Print_Status(mainw, Contacts[ i ].status );
	    wcolor_set(mainw,1,NULL);
            if ( -1L != Contacts[ i ].last_time )
            {
               if ( Contacts[ i ].status  == STATUS_OFFLINE )
                  lw_wprintw(mainw, ".  Last online at %s", ctime( (time_t *) &Contacts[ i ].last_time ) );
               else
                  lw_wprintw(mainw, ".  Online since %s", ctime( (time_t *) &Contacts[ i ].last_time )  );
            }
            else
            {
               lw_wprintw(mainw, " Last on-line unknown.\n" );
               /* if time is unknow they can't be logged on cause we */
               /* set the time at login */
            }
         }
      }
   }
   /* The second loop displays all the online users */
   for ( i=0; i< Num_Contacts; i++ )
   {
      if ( ( S_DWORD )Contacts[ i ].uin > 0 )
      {
         if ( Contacts[ i ].status != STATUS_OFFLINE )
         {
	    wcolor_set(mainw,4,NULL);
            lw_wprintw(mainw, "%8ld",Contacts[ i ].uin );
	    wcolor_set(mainw,1,NULL);
	    lw_wprintw(mainw, " = ");
	    wcolor_set(mainw,4,NULL);
            lw_wprintw(mainw, "%-8s", Contacts[ i ].nick );
            Print_Status(mainw, Contacts[ i ].status );
	    wcolor_set(mainw,1,NULL);
            if ( -1L != Contacts[ i ].last_time )
            {
               if ( Contacts[ i ].status  == STATUS_OFFLINE )
                  lw_wprintw(mainw, ". Last online at %s", ctime( (time_t *) &Contacts[ i ].last_time ) );
               else
                  lw_wprintw(mainw, ". Online since %s", ctime( (time_t *) &Contacts[ i ].last_time )  );
            }
            else
            {
               lw_wprintw(mainw, " Last on-line unknown.\n" );
               /* if time is unknow they can't be logged on cause we */
               /* set the time at login */
            }
         }
      }
   }
}

void Show_Quick_Status( void ) // reset your status line, and the buddy list
{
   int i;
   time_t htimeval;
   if ( status == 1) {
	   wcolor_set(statz,1,NULL);
           lw_wprintw(statz,"\n\nNow in Multi-Line mode to ");
           wcolor_set(statz,4,NULL);
           lw_wprintw(statz,"%s ",Get_Nick(multi_uin));
           wcolor_set(statz,1,NULL);
           lw_wprintw(statz,"(");
           wcolor_set(statz,4,NULL);
           lw_wprintw(statz,"%ld",multi_uin);
           wcolor_set(statz,1,NULL);
           lw_wprintw(statz,")");
           wcolor_set(statz,1,NULL);
   
   wrefresh(statz);
   } else {  
   htimeval = time(0);
   wcolor_set(statz,1,NULL);
   lw_wprintw(statz, "\nYour status is " );
   Print_Status(statz, Current_Status );
   wcolor_set(statz,1,NULL);
   lw_wprintw(statz,"\tLast: ");
   wcolor_set(statz,4,NULL);
   lw_wprintw(statz,"%s\t",Get_Nick(last_recv_uin));
   wcolor_set(statz,1,NULL);
   lw_wprintw(statz,"Again: ");
   wcolor_set(statz,4,NULL);
   lw_wprintw(statz,"%s",Get_Nick(last_uin));
   wcolor_set(statz,1,NULL);
   lw_wprintw(statz, "\tAuto replies: %s     ", auto_resp ? "On" : "Off" );
   }
   lw_wprintw(blist, "\n\n" W_SEPERATOR );    lw_wprintw(blist, "%lu: ", UIN );

   for ( i=0; i< LINES; i++) {
       lw_wprintw(blist, "\n" );
   }
   /*  First loop sorts thru all offline users */
   /*  This comes first so that if there are many contacts */
   /*  The online ones will be less likely to scroll off the screen */
   wcolor_set(blist,5,NULL);
   lw_wprintw(blist, W_SEPERATOR );
   lw_wprintw(blist, "Users offline: \n" );
   wcolor_set(blist,1,NULL);
   for ( i=0; i< Num_Contacts; i++ )
   {
      if ( ( S_DWORD )Contacts[ i ].uin > 0 )
      {
         if ( Contacts[ i ].status == STATUS_OFFLINE )
         {
	    wcolor_set(blist,4,NULL);
            lw_wprintw(blist, CONTACTCOL "%-8s\n", Contacts[ i ].nick );
	    wcolor_set(blist,1,NULL);
            //Print_Status(blist, Contacts[ i ].status );
            //wprintw(blist, ")" NOCOL "\n" );
         }
      }
   }
   /* The second loop displays all the online users */
   wcolor_set(blist,5,NULL);
   lw_wprintw(blist, W_SEPERATOR );
   lw_wprintw(blist, "Users online: \n" );
   wcolor_set(blist,1,NULL);
   for ( i=0; i< Num_Contacts; i++ )
   {
      if ( ( S_DWORD )Contacts[ i ].uin > 0 )
      {
         if ( Contacts[ i ].status != STATUS_OFFLINE )
         {
	    wcolor_set(blist,4,NULL);
            lw_wprintw(blist, CONTACTCOL "%-8s", Contacts[ i ].nick ); 
	    wcolor_set(blist,1,NULL);
	    lw_wprintw(blist, MESSCOL "(");
            Print_Status(blist, Contacts[ i ].status );
            lw_wprintw(blist, ")" NOCOL "\n" );
         }
      }
   }
   wcolor_set(blist,5,NULL);
   lw_wprintw(blist, W_SEPERATOR );
}
